package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.alibaba.csp.sentinel.util.StringUtil;
import com.alibaba.nacos.common.utils.CollectionUtils;
import com.lzmispt.core.entity.dto.querymodel.QueryModelDTO;
import com.lzmispt.core.service.query.IQuery;
import com.lzmispt.data.center.entity.dto.querymodel.DCQueryModelDTO;
import com.lzmispt.data.center.entity.dto.resource.metadata.EntityItemInfoSearchDTO;
import com.lzmispt.data.center.entity.dto.standard.metadata.MetadataEntityDataItemDTO;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.resource.file.FileInfoFieldVO;
import com.lzmispt.data.center.entity.vo.resource.metadata.MetadataFieldVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataEntityDataItemVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataFieldWithElementVO;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataItemAndValueVO;
import com.lzmispt.data.resource.dao.file.IFileInfoFieldDao;
import com.lzmispt.data.resource.dao.file.IFileInfoTableDao;
import com.lzmispt.data.resource.dao.metadata.IMetadataDao;
import com.lzmispt.data.resource.entity.dto.file.GetFileInfoFieldListDTO;
import com.lzmispt.data.resource.entity.dto.metadata.BatchEditDataItemDTO;
import com.lzmispt.data.resource.entity.dto.metadata.BatchEditDataItemsDTO;
import com.lzmispt.data.resource.entity.dto.metadata.CheckDataItemNameIsRepeatDTO;
import com.lzmispt.data.resource.entity.dto.metadata.DragSortMetaDataInfoItemDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.po.file.FileInfoFieldPO;
import com.lzmispt.data.resource.entity.po.file.FileInfoTablePO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityInfoItemPO;
import com.lzmispt.data.resource.manager.metadata.MetadataManager;
import com.lzmispt.data.resource.service.metadata.IInfoItem;
import com.lzmispt.data.resource.service.metadata.impl.InfoItemManager;
import com.lzmispt.dcbase.ServiceUtil;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

@Service
public class ManageInfoItemImpl extends InfoItemManager {
  @Autowired
  private IQuery query;
  
  public String getDefaultCode() {
    return "Manage";
  }
  
  public ResultEntity<Boolean> batchEditDataItem(BatchEditDataItemsDTO batchEditDataItemsDTO, String tokenId) {
    List<BatchEditDataItemDTO> batchEditDataItemDTOList = batchEditDataItemsDTO.getBatchEditDataItemDTOList();
    for (BatchEditDataItemDTO batchEditDataItemDTO : batchEditDataItemDTOList) {
      MetadataEntityInfoItemPO infoItem = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getItemInfoById(batchEditDataItemDTO.getInfoItemId());
      if (checkDataItemNameIsRepeat(batchEditDataItemDTO.getIsReference(), infoItem, tokenId, batchEditDataItemDTO.getDataItemId(), batchEditDataItemDTO.getDataItemName(), batchEditDataItemDTO.getDataItemType()))
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_METADATA_PHYSICAL_FIELD_REPEAT.getCode()), "该数据元类型下已经存在物理字段名称为【" + batchEditDataItemDTO.getDataItemName() + "】的数据元"); 
      ResultEntity<Boolean> checkExistMySql = checkExistMySql(batchEditDataItemDTO.getDataItemName(), infoItem.getEntityId(), tokenId, batchEditDataItemsDTO.getIsRes());
      if (checkExistMySql.getCode().intValue() != 0)
        return checkExistMySql; 
    } 
    for (BatchEditDataItemDTO batchEditDataItemDTO : batchEditDataItemDTOList) {
      if (batchEditDataItemDTO.getDataItemType() == null)
        batchEditDataItemDTO.setDataItemType("0"); 
      List<CheckDataItemNameIsRepeatDTO> dataItemNameList = new ArrayList<>();
      CheckDataItemNameIsRepeatDTO checkDataItemNameIsRepeatDTO = new CheckDataItemNameIsRepeatDTO();
      checkDataItemNameIsRepeatDTO.setIsReference(batchEditDataItemDTO.getIsReference());
      checkDataItemNameIsRepeatDTO.setDataItemName(batchEditDataItemDTO.getDataItemName());
      dataItemNameList.add(checkDataItemNameIsRepeatDTO);
      MetadataEntityInfoItemPO infoItem = ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).getItemInfoById(batchEditDataItemDTO.getInfoItemId());
      metadataEntityDataItemCount(batchEditDataItemDTO.getIsReference(), infoItem, tokenId, batchEditDataItemDTO.getDataItemId(), batchEditDataItemsDTO.getIsRes());
      if (batchEditDataItemDTO.getDataScale() == null)
        batchEditDataItemDTO.setDataScale(DCConst.FALSE); 
      if (infoItem != null)
        if (infoItem.getDataItemId() != null) {
          MetadataEntityDataItemVO metadataEntityDataItemVO = (MetadataEntityDataItemVO)this.dataStandardClient.getMetadataEntityDataItemById(infoItem.getDataItemId(), getDefaultCode(), tokenId).getObj();
          MetadataEntityDataItemDTO metadataEntityInfoItemDTO = new MetadataEntityDataItemDTO();
          if (metadataEntityDataItemVO != null) {
            metadataEntityDataItemVO.setDataItemName(batchEditDataItemDTO.getDataItemName());
            metadataEntityDataItemVO.setDataLength(batchEditDataItemDTO.getDataLength());
            metadataEntityDataItemVO.setDataScale(batchEditDataItemDTO.getDataScale());
            metadataEntityDataItemVO.setDataType(batchEditDataItemDTO.getDataType());
            metadataEntityDataItemVO.setDataItemType(batchEditDataItemDTO.getDataItemType());
            BeanUtils.copyProperties(metadataEntityDataItemVO, metadataEntityInfoItemDTO);
            this.dataStandardClient.updateMetadataEntityDataItemNotVerify(metadataEntityInfoItemDTO, getDefaultCode(), tokenId);
            infoItem.setDataItemId(metadataEntityDataItemVO.getDataItemId());
          } 
        } else {
          MetadataEntityDataItemDTO metadataEntityInfoItemDTO = new MetadataEntityDataItemDTO();
          BeanUtils.copyProperties(batchEditDataItemDTO, metadataEntityInfoItemDTO);
          if (batchEditDataItemDTO.getIsReference().equals(DCConst.TRUE) && metadataEntityInfoItemDTO.getDataItemType().equals("0")) {
            MetadataEntityDataItemVO metadataEntityDataItemVO1 = (MetadataEntityDataItemVO)this.dataStandardClient.getMetadataEntityDataItemById(batchEditDataItemDTO.getDataItemId(), getDefaultCode(), tokenId).getObj();
            BeanUtils.copyProperties(metadataEntityDataItemVO1, metadataEntityInfoItemDTO);
          } 
          if (infoItem.getIsReference().equals(DCConst.TRUE) && batchEditDataItemDTO.getIsReference().equals(DCConst.FALSE)) {
            MetadataEntityDataItemVO oldMetadataEntityDataItemVO = (MetadataEntityDataItemVO)this.dataStandardClient.getMetadataEntityDataItemById(batchEditDataItemDTO.getDataItemId(), getDefaultCode(), tokenId).getObj();
            metadataEntityInfoItemDTO.setDataItemCnName(oldMetadataEntityDataItemVO.getDataItemCnName());
            metadataEntityInfoItemDTO.setDescription(oldMetadataEntityDataItemVO.getDescription());
            metadataEntityInfoItemDTO.setDataItemCode(oldMetadataEntityDataItemVO.getDataItemCode());
          } 
          if ("0".equalsIgnoreCase(metadataEntityInfoItemDTO.getDataItemType()) && (
            metadataEntityInfoItemDTO.getDataItemCnName() == null || StringUtils.isEmpty(metadataEntityInfoItemDTO.getDataItemCnName())))
            metadataEntityInfoItemDTO.setDataItemCnName(infoItem.getInfoItemName()); 
          MetadataEntityDataItemVO metadataEntityDataItemVO = (MetadataEntityDataItemVO)this.dataStandardClient.addMetadataEntityDataItemNotVerify(metadataEntityInfoItemDTO, getDefaultCode(), tokenId).getObj();
          infoItem.setDataItemId(metadataEntityDataItemVO.getDataItemId());
        }  
      infoItem.setUpdateTime(new Date());
      infoItem.setIsPrimaryKey(batchEditDataItemDTO.getIsPrimaryKey());
      infoItem.setIsReference(batchEditDataItemDTO.getIsReference());
      ((IMetadataDao)ServiceUtil.getMetadataDao(getDefaultCode(), IMetadataDao.class)).updateInfoItem(infoItem);
    } 
    return ResultEntity.successMessage(Boolean.valueOf(true));
  }
  
  public ResultEntity<Boolean> dragMetadataInfoItem(DragSortMetaDataInfoItemDTO dataInfoItemDTO, String platCode, String tokenId) {
    Boolean flag = Boolean.valueOf(false);
    if (!StringUtils.isEmpty(dataInfoItemDTO.getEntityId())) {
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(dataInfoItemDTO.getEntityId(), dataInfoItemDTO.getIsResources(), platCode, tokenId);
      ResAndDataEntityDTO resAndDataEntityDTO1 = resAndDataEntityDTO;
      if (resAndDataEntityDTO1 == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getMessage()); 
      EntityItemInfoSearchDTO searchDTO = new EntityItemInfoSearchDTO();
      searchDTO.setEntityId(dataInfoItemDTO.getEntityId());
      searchDTO.setPlatCode(platCode);
      List<Long> ids = dataInfoItemDTO.getIds();
      if (CollectionUtils.isNotEmpty(ids)) {
        ResultEntity<List<MetadataFieldWithElementVO>> saveFieldsRet = MetadataManager.saveFieldData(resAndDataEntityDTO, tokenId, platCode, null, "lzdc_sys_serial_number", ids, dataInfoItemDTO.getIsResources());
        flag = Boolean.valueOf(saveFieldsRet.getCode().equals(DCConst.FALSE));
      } 
      if (!flag.booleanValue())
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getMessage()); 
    } 
    return ResultEntity.successMessage(flag);
  }
  
  public ResultEntity<List<FileInfoFieldVO>> getFileInfoItemList(GetFileInfoFieldListDTO getFileInfoFieldListDTO, String platCode, String tokenId) {
    IFileInfoFieldDao fileInfoFieldDao = (IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(getDefaultCode(), IFileInfoFieldDao.class);
    List<Long> notInFieldId = new ArrayList<>();
    DCQueryModelDTO queryModel = getFileInfoFieldListDTO.getQuery();
    String whereSql = null;
    List<FileInfoFieldPO> allFileInfoFieldList = fileInfoFieldDao.selectFileInfoFieldsByFileTableId(getFileInfoFieldListDTO.getFileTableId(), null);
    for (FileInfoFieldPO fileInfoFieldPO : allFileInfoFieldList) {
      if (DCConst.TRUE.equals(fileInfoFieldPO.getIsSystem()))
        notInFieldId.add(fileInfoFieldPO.getFieldId()); 
    } 
    StringBuilder notInFieldIdStr = new StringBuilder();
    for (int i = 0; i < notInFieldId.size(); i++) {
      Long fieldId = notInFieldId.get(i);
      if (i == notInFieldId.size() - 1) {
        notInFieldIdStr.append(fieldId);
      } else {
        notInFieldIdStr.append(fieldId).append(",");
      } 
    } 
    if (!StringUtils.isEmpty(notInFieldIdStr.toString())) {
      whereSql = "and fieldid not in (" + notInFieldIdStr + ")";
    } else {
      whereSql = "and fieldid not in ('')";
    } 
    if (queryModel != null) {
      boolean isEscapeStr = false;
      if (whereSql != null) {
        whereSql = whereSql + (String)this.query.getWhereSqlStr((QueryModelDTO)queryModel, "mysql", true, isEscapeStr).getObj();
      } else {
        whereSql = (String)this.query.getWhereSqlStr((QueryModelDTO)queryModel, "mysql", true, isEscapeStr).getObj();
      } 
      if (!StringUtil.isEmpty(whereSql) && queryModel.getFilterModel() != null)
        whereSql = " and " + whereSql; 
      whereSql = whereSql.replaceAll("`fieldCode`", "`field_code`");
    } 
    List<FileInfoFieldPO> fileInfoFieldList = fileInfoFieldDao.selectFileInfoFieldsByFileTableId(getFileInfoFieldListDTO.getFileTableId(), whereSql);
    List<FileInfoFieldVO> fileInfoFieldVOS = null;
    if (CollectionUtils.isNotEmpty(fileInfoFieldList))
      fileInfoFieldVOS = (List<FileInfoFieldVO>)fileInfoFieldList.stream().map(fileInfoFieldPO -> {
            FileInfoFieldVO fileInfoFieldVO = new FileInfoFieldVO();
            BeanUtils.copyProperties(fileInfoFieldPO, fileInfoFieldVO);
            return fileInfoFieldVO;
          }).collect(Collectors.toList()); 
    return ResultEntity.successMessage(fileInfoFieldVOS);
  }
  
  public ResultEntity<Boolean> dragFileInfoItem(DragSortMetaDataInfoItemDTO dataInfoItemDTO, String platCode, String tokenId) {
    Integer flag = Integer.valueOf(0);
    IFileInfoFieldDao fileInfoFieldDao = (IFileInfoFieldDao)ServiceUtil.getFileInfoFieldDao(getDefaultCode(), IFileInfoFieldDao.class);
    IFileInfoTableDao fileInfoTableDao = (IFileInfoTableDao)ServiceUtil.getFileInfoTableDao(getDefaultCode(), IFileInfoTableDao.class);
    FileInfoTablePO fileInfoTablePO = fileInfoTableDao.selectFileInfoTable(dataInfoItemDTO.getEntityId());
    if (fileInfoTablePO == null || DCConst.TRUE.equals(fileInfoTablePO.getIsDelete()))
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_FILE_INFO_TABLE_NO_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_FILE_INFO_TABLE_NO_EXISTS.getMessage()); 
    List<Long> ids = dataInfoItemDTO.getIds();
    Integer systemFieldCount = fileInfoFieldDao.selectSystemFieldCountById(dataInfoItemDTO.getEntityId());
    if (CollectionUtils.isNotEmpty(ids))
      for (int i = 0; i < ids.size(); i++) {
        FileInfoFieldPO fileInfoFieldPO = new FileInfoFieldPO();
        fileInfoFieldPO.setFieldId(ids.get(i));
        fileInfoFieldPO.setFieldOrder(systemFieldCount = Integer.valueOf(systemFieldCount.intValue() + 1));
        flag = Integer.valueOf(fileInfoFieldDao.updateFileInfoFieldSelective(fileInfoFieldPO));
      }  
    return ResultEntity.successMessage(Boolean.valueOf((flag.intValue() >= 0)));
  }
  
  public ResultEntity<List<MetadataFieldVO>> getInfoItemList(EntityItemInfoSearchDTO entityItemInfoSearchDTO, String platCode, String tokenId) {
    List<MetadataFieldVO> metadataFieldVOList = new ArrayList<>();
    if (!StringUtils.isEmpty(entityItemInfoSearchDTO.getEntityId())) {
      ResAndDataEntityDTO resAndDataEntityDTO = MetadataManager.selectEntityByEntityId(entityItemInfoSearchDTO.getEntityId(), entityItemInfoSearchDTO.getIsResources(), platCode, tokenId);
      if (resAndDataEntityDTO == null)
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_FOUND_DATA_RESOURCE_ENTITY.getMessage()); 
      ResultEntity<MetadataItemAndValueVO> metadataItemAndValueVOResultEntity = ((IInfoItem)ServiceUtil.getInfoItemManager(platCode, IInfoItem.class)).getInfoItems(entityItemInfoSearchDTO);
      if (metadataItemAndValueVOResultEntity != null && metadataItemAndValueVOResultEntity.getObj() != null && ((MetadataItemAndValueVO)metadataItemAndValueVOResultEntity.getObj()).getData() != null)
        for (int i = 0; i < ((MetadataItemAndValueVO)metadataItemAndValueVOResultEntity.getObj()).getData().size(); i++) {
          Map<String, Object> infoItem = ((MetadataItemAndValueVO)metadataItemAndValueVOResultEntity.getObj()).getData().get(i);
          if (infoItem != null) {
            MetadataEntityInfoItemPO metadataEntityInfoItemPO = this.metadataField.metadataFieldToInfoItem(infoItem);
            MetadataFieldVO metadataFieldVO = new MetadataFieldVO();
            BeanUtils.copyProperties(metadataEntityInfoItemPO, metadataFieldVO);
            metadataFieldVOList.add(metadataFieldVO);
          } 
        }  
    } 
    return ResultEntity.successMessage(metadataFieldVOList);
  }
  
  private String batchCheckBindEntity(List<BatchEditDataItemDTO> batchEditDataItemDTOList, Long entityId, String tokenId, Integer isRes) {
    for (int i = 0; i < batchEditDataItemDTOList.size() - 1; i++) {
      for (int j = batchEditDataItemDTOList.size() - 1; j > i; j--) {
        if (((BatchEditDataItemDTO)batchEditDataItemDTOList.get(j)).getDataItemId().equals(((BatchEditDataItemDTO)batchEditDataItemDTOList.get(i)).getDataItemId()))
          return ((BatchEditDataItemDTO)batchEditDataItemDTOList.get(j)).getDataItemName(); 
      } 
    } 
    List<MetadataEntityInfoItemPO> metadataEntityInfoItemlist = ((IInfoItem)ServiceUtil.getInfoItemManager(getDefaultCode(), IInfoItem.class)).getEntityInfoItemsByEntityId(entityId, getDefaultCode(), isRes, tokenId);
    metadataEntityInfoItemlist = (List<MetadataEntityInfoItemPO>)metadataEntityInfoItemlist.stream().filter(s -> DCConst.TRUE.equals(s.getInfoItemStatus())).collect(Collectors.toList());
    for (BatchEditDataItemDTO batchEditDataItemDTO : batchEditDataItemDTOList) {
      for (MetadataEntityInfoItemPO metadataEntityInfoItemPO : metadataEntityInfoItemlist) {
        if (metadataEntityInfoItemPO.getDataItemId() != null && metadataEntityInfoItemPO.getDataItemId().equals(batchEditDataItemDTO.getDataItemId()))
          return batchEditDataItemDTO.getDataItemName(); 
      } 
    } 
    return "";
  }
  
  private MetadataEntityInfoItemPO getItemInfoById(Long infoItemId, String tokenId, Integer isRes) {
    List<Long> ids = new ArrayList<>();
    ids.add(infoItemId);
    List<MetadataFieldWithElementVO> metadataFieldWithElementVOS = (List<MetadataFieldWithElementVO>)this.dataStandardClient.getFieldWithElementByIds(ids, isRes, getDefaultCode(), tokenId).getObj();
    MetadataEntityInfoItemPO metadataEntityInfoItem = this.metadataField.metadataFieldToInfoItem(metadataFieldWithElementVOS).get(0);
    return metadataEntityInfoItem;
  }
  
  public ResultEntity getDataFieldMetadataVersions(QueryModelDTO queryModelDTO, String platCode, String tokenId) {
    return null;
  }
}
